#ifndef LDMA_CLASS_H
#define LDMA_CLASS_H

#include "em_ldma.h"

typedef enum							LdmaClassSignal_e
{
	LdmaClassSignal_NONE = LDMA_CH_REQSEL_SOURCESEL_NONE,                                                              ///< No peripheral selected for DMA triggering.
	#if defined(LDMA_CH_REQSEL_SIGSEL_ADC0SCAN)
	LdmaClassSignal_ADC0_SCAN = LDMA_CH_REQSEL_SIGSEL_ADC0SCAN | LDMA_CH_REQSEL_SOURCESEL_ADC0,                        ///< Trig on ADC0_SCAN.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_ADC0SINGLE)
	LdmaClassSignal_ADC0_SINGLE = LDMA_CH_REQSEL_SIGSEL_ADC0SINGLE | LDMA_CH_REQSEL_SOURCESEL_ADC0,                    ///< Trig on ADC0_SINGLE.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_ADC1SCAN)
	LdmaClassSignal_ADC1_SCAN = LDMA_CH_REQSEL_SIGSEL_ADC1SCAN | LDMA_CH_REQSEL_SOURCESEL_ADC1,                        ///< Trig on ADC1_SCAN.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_ADC1SINGLE)
	LdmaClassSignal_ADC1_SINGLE = LDMA_CH_REQSEL_SIGSEL_ADC1SINGLE | LDMA_CH_REQSEL_SOURCESEL_ADC1,                    ///< Trig on ADC1_SINGLE.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_VDAC0CH0)
	LdmaClassSignal_VDAC0_CH0 = LDMA_CH_REQSEL_SIGSEL_VDAC0CH0 | LDMA_CH_REQSEL_SOURCESEL_VDAC0,                       ///< Trig on VDAC0_CH0
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_VDAC0CH1)
	LdmaClassSignal_VDAC0_CH1 = LDMA_CH_REQSEL_SIGSEL_VDAC0CH1 | LDMA_CH_REQSEL_SOURCESEL_VDAC0,                       ///< Trig on VDAC0_CH1
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_AGCRSSI)
	LdmaClassSignal_AGC_RSSI = LDMA_CH_REQSEL_SIGSEL_AGCRSSI | LDMA_CH_REQSEL_SOURCESEL_AGC,                           ///< Trig on AGC_RSSI.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTODATA0RD)
	LdmaClassSignal_CRYPTO_DATA0RD = LDMA_CH_REQSEL_SIGSEL_CRYPTODATA0RD | LDMA_CH_REQSEL_SOURCESEL_CRYPTO,            ///< Trig on CRYPTO_DATA0RD.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTODATA0WR)
	LdmaClassSignal_CRYPTO_DATA0WR = LDMA_CH_REQSEL_SIGSEL_CRYPTODATA0WR | LDMA_CH_REQSEL_SOURCESEL_CRYPTO,            ///< Trig on CRYPTO_DATA0WR.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTODATA0XWR)
	LdmaClassSignal_CRYPTO_DATA0XWR = LDMA_CH_REQSEL_SIGSEL_CRYPTODATA0XWR | LDMA_CH_REQSEL_SOURCESEL_CRYPTO,          ///< Trig on CRYPTO_DATA0XWR.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTODATA1RD)
	LdmaClassSignal_CRYPTO_DATA1RD = LDMA_CH_REQSEL_SIGSEL_CRYPTODATA1RD | LDMA_CH_REQSEL_SOURCESEL_CRYPTO,            ///< Trig on CRYPTO_DATA1RD.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTODATA1WR)
	LdmaClassSignal_CRYPTO_DATA1WR = LDMA_CH_REQSEL_SIGSEL_CRYPTODATA1WR | LDMA_CH_REQSEL_SOURCESEL_CRYPTO,            ///< Trig on CRYPTO_DATA1WR.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTO0DATA0RD)
	LdmaClassSignal_CRYPTO0_DATA0RD = LDMA_CH_REQSEL_SIGSEL_CRYPTO0DATA0RD | LDMA_CH_REQSEL_SOURCESEL_CRYPTO0,         ///< Trig on CRYPTO0_DATA0RD.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTO0DATA0WR)
	LdmaClassSignal_CRYPTO0_DATA0WR = LDMA_CH_REQSEL_SIGSEL_CRYPTO0DATA0WR | LDMA_CH_REQSEL_SOURCESEL_CRYPTO0,         ///< Trig on CRYPTO0_DATA0WR.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTO0DATA0XWR)
	LdmaClassSignal_CRYPTO0_DATA0XWR = LDMA_CH_REQSEL_SIGSEL_CRYPTO0DATA0XWR | LDMA_CH_REQSEL_SOURCESEL_CRYPTO0,       ///< Trig on CRYPTO0_DATA0XWR.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTO0DATA1RD)
	LdmaClassSignal_CRYPTO0_DATA1RD = LDMA_CH_REQSEL_SIGSEL_CRYPTO0DATA1RD | LDMA_CH_REQSEL_SOURCESEL_CRYPTO0,         ///< Trig on CRYPTO0_DATA1RD.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTO0DATA1WR)
	LdmaClassSignal_CRYPTO0_DATA1WR = LDMA_CH_REQSEL_SIGSEL_CRYPTO0DATA1WR | LDMA_CH_REQSEL_SOURCESEL_CRYPTO0,         ///< Trig on CRYPTO0_DATA1WR.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTO1DATA0RD)
	LdmaClassSignal_CRYPTO1_DATA0RD = LDMA_CH_REQSEL_SIGSEL_CRYPTO1DATA0RD | LDMA_CH_REQSEL_SOURCESEL_CRYPTO1,         ///< Trig on CRYPTO1_DATA0RD.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTO1DATA0WR)
	LdmaClassSignal_CRYPTO1_DATA0WR = LDMA_CH_REQSEL_SIGSEL_CRYPTO1DATA0WR | LDMA_CH_REQSEL_SOURCESEL_CRYPTO1,         ///< Trig on CRYPTO1_DATA0WR.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTO1DATA0XWR)
	LdmaClassSignal_CRYPTO1_DATA0XWR = LDMA_CH_REQSEL_SIGSEL_CRYPTO1DATA0XWR | LDMA_CH_REQSEL_SOURCESEL_CRYPTO1,       ///< Trig on CRYPTO1_DATA0XWR.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTO1DATA1RD)
	LdmaClassSignal_CRYPTO1_DATA1RD = LDMA_CH_REQSEL_SIGSEL_CRYPTO1DATA1RD | LDMA_CH_REQSEL_SOURCESEL_CRYPTO1,         ///< Trig on CRYPTO1_DATA1RD.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CRYPTO1DATA1WR)
	LdmaClassSignal_CRYPTO1_DATA1WR = LDMA_CH_REQSEL_SIGSEL_CRYPTO1DATA1WR | LDMA_CH_REQSEL_SOURCESEL_CRYPTO1,         ///< Trig on CRYPTO1_DATA1WR.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_EBIPXL0EMPTY)
	LdmaClassSignal_EBI_PXL0EMPTY = LDMA_CH_REQSEL_SIGSEL_EBIPXL0EMPTY | LDMA_CH_REQSEL_SOURCESEL_EBI,                 ///< Trig on EBI_PXL0EMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_EBIPXL1EMPTY)
	LdmaClassSignal_EBI_PXL1EMPTY = LDMA_CH_REQSEL_SIGSEL_EBIPXL1EMPTY | LDMA_CH_REQSEL_SOURCESEL_EBI,                 ///< Trig on EBI_PXL1EMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_EBIPXLFULL)
	LdmaClassSignal_EBI_PXLFULL = LDMA_CH_REQSEL_SIGSEL_EBIPXLFULL | LDMA_CH_REQSEL_SOURCESEL_EBI,                      ///< Trig on EBI_PXLFULL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_EBIDDEMPTY)
	LdmaClassSignal_EBI_DDEMPTY = LDMA_CH_REQSEL_SIGSEL_EBIDDEMPTY | LDMA_CH_REQSEL_SOURCESEL_EBI,                      ///< Trig on EBI_DDEMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_EBIVSYNC)
	LdmaClassSignal_EBI_VSYNC = LDMA_CH_REQSEL_SIGSEL_EBIVSYNC | LDMA_CH_REQSEL_SOURCESEL_EBI,                          ///< Trig on EBI_VSYNC.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_EBIHSYNC)
	LdmaClassSignal_EBI_HSYNC = LDMA_CH_REQSEL_SIGSEL_EBIHSYNC | LDMA_CH_REQSEL_SOURCESEL_EBI,                          ///< Trig on EBI_HSYNC.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CSENDATA)
	LdmaClassSignal_CSEN_DATA = LDMA_CH_REQSEL_SIGSEL_CSENDATA | LDMA_CH_REQSEL_SOURCESEL_CSEN,                         ///< Trig on CSEN_DATA.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_CSENBSLN)
	LdmaClassSignal_CSEN_BSLN = LDMA_CH_REQSEL_SIGSEL_CSENBSLN | LDMA_CH_REQSEL_SOURCESEL_CSEN,                         ///< Trig on CSEN_BSLN.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_LSENSEBUFDATAV)
	LdmaClassSignal_LESENSE_BUFDATAV = LDMA_CH_REQSEL_SIGSEL_LSENSEBUFDATAV | LDMA_CH_REQSEL_SOURCESEL_LESENSE,         ///< Trig on LESENSE_BUFDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_I2C0RXDATAV)
	LdmaClassSignal_I2C0_RXDATAV = LDMA_CH_REQSEL_SIGSEL_I2C0RXDATAV | LDMA_CH_REQSEL_SOURCESEL_I2C0,                  ///< Trig on I2C0_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_I2C0TXBL)
	LdmaClassSignal_I2C0_TXBL = LDMA_CH_REQSEL_SIGSEL_I2C0TXBL | LDMA_CH_REQSEL_SOURCESEL_I2C0,                        ///< Trig on I2C0_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_I2C1RXDATAV)
	LdmaClassSignal_I2C1_RXDATAV = LDMA_CH_REQSEL_SIGSEL_I2C1RXDATAV | LDMA_CH_REQSEL_SOURCESEL_I2C1,                  ///< Trig on I2C1_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_I2C1TXBL)
	LdmaClassSignal_I2C1_TXBL = LDMA_CH_REQSEL_SIGSEL_I2C1TXBL | LDMA_CH_REQSEL_SOURCESEL_I2C1,                        ///< Trig on I2C1_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_I2C2RXDATAV)
	LdmaClassSignal_I2C2_RXDATAV = LDMA_CH_REQSEL_SIGSEL_I2C2RXDATAV | LDMA_CH_REQSEL_SOURCESEL_I2C2,                  ///< Trig on I2C2_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_I2C2TXBL)
	LdmaClassSignal_I2C2_TXBL = LDMA_CH_REQSEL_SIGSEL_I2C2TXBL | LDMA_CH_REQSEL_SOURCESEL_I2C2,                        ///< Trig on I2C2_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_LEUART0RXDATAV)
	LdmaClassSignal_LEUART0_RXDATAV = LDMA_CH_REQSEL_SIGSEL_LEUART0RXDATAV | LDMA_CH_REQSEL_SOURCESEL_LEUART0,         ///< Trig on LEUART0_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_LEUART0TXBL)
	LdmaClassSignal_LEUART0_TXBL = LDMA_CH_REQSEL_SIGSEL_LEUART0TXBL | LDMA_CH_REQSEL_SOURCESEL_LEUART0,               ///< Trig on LEUART0_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_LEUART0TXEMPTY)
	LdmaClassSignal_LEUART0_TXEMPTY = LDMA_CH_REQSEL_SIGSEL_LEUART0TXEMPTY | LDMA_CH_REQSEL_SOURCESEL_LEUART0,         ///< Trig on LEUART0_TXEMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_LEUART1RXDATAV)
	LdmaClassSignal_LEUART1_RXDATAV = LDMA_CH_REQSEL_SIGSEL_LEUART1RXDATAV | LDMA_CH_REQSEL_SOURCESEL_LEUART1,         ///< Trig on LEUART1_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_LEUART1TXBL)
	LdmaClassSignal_LEUART1_TXBL = LDMA_CH_REQSEL_SIGSEL_LEUART1TXBL | LDMA_CH_REQSEL_SOURCESEL_LEUART1,               ///< Trig on LEUART1_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_LEUART1TXEMPTY)
	LdmaClassSignal_LEUART1_TXEMPTY = LDMA_CH_REQSEL_SIGSEL_LEUART1TXEMPTY | LDMA_CH_REQSEL_SOURCESEL_LEUART1,         ///< Trig on LEUART1_TXEMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_MODEMDEBUG)
	LdmaClassSignal_MODEM_DEBUG = LDMA_CH_REQSEL_SIGSEL_MODEMDEBUG | LDMA_CH_REQSEL_SOURCESEL_MODEM,                   ///< Trig on MODEM_DEBUG.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_MSCWDATA)
	LdmaClassSignal_MSC_WDATA = LDMA_CH_REQSEL_SIGSEL_MSCWDATA | LDMA_CH_REQSEL_SOURCESEL_MSC,                         ///< Trig on MSC_WDATA.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_PROTIMERBOF)
	LdmaClassSignal_PROTIMER_BOF = LDMA_CH_REQSEL_SIGSEL_PROTIMERBOF | LDMA_CH_REQSEL_SOURCESEL_PROTIMER,              ///< Trig on PROTIMER_BOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_PROTIMERCC0)
	LdmaClassSignal_PROTIMER_CC0 = LDMA_CH_REQSEL_SIGSEL_PROTIMERCC0 | LDMA_CH_REQSEL_SOURCESEL_PROTIMER,              ///< Trig on PROTIMER_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_PROTIMERCC1)
	LdmaClassSignal_PROTIMER_CC1 = LDMA_CH_REQSEL_SIGSEL_PROTIMERCC1 | LDMA_CH_REQSEL_SOURCESEL_PROTIMER,              ///< Trig on PROTIMER_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_PROTIMERCC2)
	LdmaClassSignal_PROTIMER_CC2 = LDMA_CH_REQSEL_SIGSEL_PROTIMERCC2 | LDMA_CH_REQSEL_SOURCESEL_PROTIMER,              ///< Trig on PROTIMER_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_PROTIMERCC3)
	LdmaClassSignal_PROTIMER_CC3 = LDMA_CH_REQSEL_SIGSEL_PROTIMERCC3 | LDMA_CH_REQSEL_SOURCESEL_PROTIMER,              ///< Trig on PROTIMER_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_PROTIMERCC4)
	LdmaClassSignal_PROTIMER_CC4 = LDMA_CH_REQSEL_SIGSEL_PROTIMERCC4 | LDMA_CH_REQSEL_SOURCESEL_PROTIMER,              ///< Trig on PROTIMER_CC4.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_PROTIMERPOF)
	LdmaClassSignal_PROTIMER_POF = LDMA_CH_REQSEL_SIGSEL_PROTIMERPOF | LDMA_CH_REQSEL_SOURCESEL_PROTIMER,              ///< Trig on PROTIMER_POF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_PROTIMERWOF)
	LdmaClassSignal_PROTIMER_WOF = LDMA_CH_REQSEL_SIGSEL_PROTIMERWOF | LDMA_CH_REQSEL_SOURCESEL_PROTIMER,              ///< Trig on PROTIMER_WOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_PRSREQ0)
	LdmaClassSignal_PRS_REQ0 = LDMA_CH_REQSEL_SIGSEL_PRSREQ0 | LDMA_CH_REQSEL_SOURCESEL_PRS,                           ///< Trig on PRS_REQ0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_PRSREQ1)
	LdmaClassSignal_PRS_REQ1 = LDMA_CH_REQSEL_SIGSEL_PRSREQ1 | LDMA_CH_REQSEL_SOURCESEL_PRS,                           ///< Trig on PRS_REQ1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER0CC0)
	LdmaClassSignal_TIMER0_CC0 = LDMA_CH_REQSEL_SIGSEL_TIMER0CC0 | LDMA_CH_REQSEL_SOURCESEL_TIMER0,                    ///< Trig on TIMER0_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER0CC1)
	LdmaClassSignal_TIMER0_CC1 = LDMA_CH_REQSEL_SIGSEL_TIMER0CC1 | LDMA_CH_REQSEL_SOURCESEL_TIMER0,                    ///< Trig on TIMER0_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER0CC2)
	LdmaClassSignal_TIMER0_CC2 = LDMA_CH_REQSEL_SIGSEL_TIMER0CC2 | LDMA_CH_REQSEL_SOURCESEL_TIMER0,                    ///< Trig on TIMER0_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER0CC3)
	LdmaClassSignal_TIMER0_CC3 = LDMA_CH_REQSEL_SIGSEL_TIMER0CC3 | LDMA_CH_REQSEL_SOURCESEL_TIMER0,                    ///< Trig on TIMER0_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER0UFOF)
	LdmaClassSignal_TIMER0_UFOF = LDMA_CH_REQSEL_SIGSEL_TIMER0UFOF | LDMA_CH_REQSEL_SOURCESEL_TIMER0,                  ///< Trig on TIMER0_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER1CC0)
	LdmaClassSignal_TIMER1_CC0 = LDMA_CH_REQSEL_SIGSEL_TIMER1CC0 | LDMA_CH_REQSEL_SOURCESEL_TIMER1,                    ///< Trig on TIMER1_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER1CC1)
	LdmaClassSignal_TIMER1_CC1 = LDMA_CH_REQSEL_SIGSEL_TIMER1CC1 | LDMA_CH_REQSEL_SOURCESEL_TIMER1,                    ///< Trig on TIMER1_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER1CC2)
	LdmaClassSignal_TIMER1_CC2 = LDMA_CH_REQSEL_SIGSEL_TIMER1CC2 | LDMA_CH_REQSEL_SOURCESEL_TIMER1,                    ///< Trig on TIMER1_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER1CC3)
	LdmaClassSignal_TIMER1_CC3 = LDMA_CH_REQSEL_SIGSEL_TIMER1CC3 | LDMA_CH_REQSEL_SOURCESEL_TIMER1,                    ///< Trig on TIMER1_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER1UFOF)
	LdmaClassSignal_TIMER1_UFOF = LDMA_CH_REQSEL_SIGSEL_TIMER1UFOF | LDMA_CH_REQSEL_SOURCESEL_TIMER1,                  ///< Trig on TIMER1_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER2CC0)
	LdmaClassSignal_TIMER2_CC0 = LDMA_CH_REQSEL_SIGSEL_TIMER2CC0 | LDMA_CH_REQSEL_SOURCESEL_TIMER2,                    ///< Trig on TIMER2_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER2CC1)
	LdmaClassSignal_TIMER2_CC1 = LDMA_CH_REQSEL_SIGSEL_TIMER2CC1 | LDMA_CH_REQSEL_SOURCESEL_TIMER2,                    ///< Trig on TIMER2_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER2CC2)
	LdmaClassSignal_TIMER2_CC2 = LDMA_CH_REQSEL_SIGSEL_TIMER2CC2 | LDMA_CH_REQSEL_SOURCESEL_TIMER2,                    ///< Trig on TIMER2_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER2CC3)
	LdmaClassSignal_TIMER2_CC3 = LDMA_CH_REQSEL_SIGSEL_TIMER2CC3 | LDMA_CH_REQSEL_SOURCESEL_TIMER2,                    ///< Trig on TIMER2_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER2UFOF)
	LdmaClassSignal_TIMER2_UFOF = LDMA_CH_REQSEL_SIGSEL_TIMER2UFOF | LDMA_CH_REQSEL_SOURCESEL_TIMER2,                  ///< Trig on TIMER2_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER3CC0)
	LdmaClassSignal_TIMER3_CC0 = LDMA_CH_REQSEL_SIGSEL_TIMER3CC0 | LDMA_CH_REQSEL_SOURCESEL_TIMER3,                    ///< Trig on TIMER3_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER3CC1)
	LdmaClassSignal_TIMER3_CC1 = LDMA_CH_REQSEL_SIGSEL_TIMER3CC1 | LDMA_CH_REQSEL_SOURCESEL_TIMER3,                    ///< Trig on TIMER3_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER3CC2)
	LdmaClassSignal_TIMER3_CC2 = LDMA_CH_REQSEL_SIGSEL_TIMER3CC2 | LDMA_CH_REQSEL_SOURCESEL_TIMER3,                    ///< Trig on TIMER3_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER3CC3)
	LdmaClassSignal_TIMER3_CC3 = LDMA_CH_REQSEL_SIGSEL_TIMER3CC3 | LDMA_CH_REQSEL_SOURCESEL_TIMER3,                    ///< Trig on TIMER3_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER3UFOF)
	LdmaClassSignal_TIMER3_UFOF = LDMA_CH_REQSEL_SIGSEL_TIMER3UFOF | LDMA_CH_REQSEL_SOURCESEL_TIMER3,                  ///< Trig on TIMER3_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER4CC0)
	LdmaClassSignal_TIMER4_CC0 = LDMA_CH_REQSEL_SIGSEL_TIMER4CC0 | LDMA_CH_REQSEL_SOURCESEL_TIMER4,                    ///< Trig on TIMER4_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER4CC1)
	LdmaClassSignal_TIMER4_CC1 = LDMA_CH_REQSEL_SIGSEL_TIMER4CC1 | LDMA_CH_REQSEL_SOURCESEL_TIMER4,                    ///< Trig on TIMER4_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER4CC2)
	LdmaClassSignal_TIMER4_CC2 = LDMA_CH_REQSEL_SIGSEL_TIMER4CC2 | LDMA_CH_REQSEL_SOURCESEL_TIMER4,                    ///< Trig on TIMER4_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER4CC3)
	LdmaClassSignal_TIMER4_CC3 = LDMA_CH_REQSEL_SIGSEL_TIMER4CC3 | LDMA_CH_REQSEL_SOURCESEL_TIMER4,                    ///< Trig on TIMER4_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER4UFOF)
	LdmaClassSignal_TIMER4_UFOF = LDMA_CH_REQSEL_SIGSEL_TIMER4UFOF | LDMA_CH_REQSEL_SOURCESEL_TIMER4,                  ///< Trig on TIMER4_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER5CC0)
	LdmaClassSignal_TIMER5_CC0 = LDMA_CH_REQSEL_SIGSEL_TIMER5CC0 | LDMA_CH_REQSEL_SOURCESEL_TIMER5,                    ///< Trig on TIMER5_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER5CC1)
	LdmaClassSignal_TIMER5_CC1 = LDMA_CH_REQSEL_SIGSEL_TIMER5CC1 | LDMA_CH_REQSEL_SOURCESEL_TIMER5,                    ///< Trig on TIMER5_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER5CC2)
	LdmaClassSignal_TIMER5_CC2 = LDMA_CH_REQSEL_SIGSEL_TIMER5CC2 | LDMA_CH_REQSEL_SOURCESEL_TIMER5,                    ///< Trig on TIMER5_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER5CC3)
	LdmaClassSignal_TIMER5_CC3 = LDMA_CH_REQSEL_SIGSEL_TIMER5CC3 | LDMA_CH_REQSEL_SOURCESEL_TIMER5,                    ///< Trig on TIMER5_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER5UFOF)
	LdmaClassSignal_TIMER5_UFOF = LDMA_CH_REQSEL_SIGSEL_TIMER5UFOF | LDMA_CH_REQSEL_SOURCESEL_TIMER5,                  ///< Trig on TIMER5_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER6CC0)
	LdmaClassSignal_TIMER6_CC0 = LDMA_CH_REQSEL_SIGSEL_TIMER6CC0 | LDMA_CH_REQSEL_SOURCESEL_TIMER6,                    ///< Trig on TIMER6_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER6CC1)
	LdmaClassSignal_TIMER6_CC1 = LDMA_CH_REQSEL_SIGSEL_TIMER6CC1 | LDMA_CH_REQSEL_SOURCESEL_TIMER6,                    ///< Trig on TIMER6_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER6CC2)
	LdmaClassSignal_TIMER6_CC2 = LDMA_CH_REQSEL_SIGSEL_TIMER6CC2 | LDMA_CH_REQSEL_SOURCESEL_TIMER6,                    ///< Trig on TIMER6_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER6CC3)
	LdmaClassSignal_TIMER6_CC3 = LDMA_CH_REQSEL_SIGSEL_TIMER6CC3 | LDMA_CH_REQSEL_SOURCESEL_TIMER6,                    ///< Trig on TIMER6_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_TIMER6UFOF)
	LdmaClassSignal_TIMER6_UFOF = LDMA_CH_REQSEL_SIGSEL_TIMER6UFOF | LDMA_CH_REQSEL_SOURCESEL_TIMER6,                  ///< Trig on TIMER6_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER0CC0)
	LdmaClassSignal_WTIMER0_CC0 = LDMA_CH_REQSEL_SIGSEL_WTIMER0CC0 | LDMA_CH_REQSEL_SOURCESEL_WTIMER0,                 ///< Trig on WTIMER0_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER0CC1)
	LdmaClassSignal_WTIMER0_CC1 = LDMA_CH_REQSEL_SIGSEL_WTIMER0CC1 | LDMA_CH_REQSEL_SOURCESEL_WTIMER0,                 ///< Trig on WTIMER0_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER0CC2)
	LdmaClassSignal_WTIMER0_CC2 = LDMA_CH_REQSEL_SIGSEL_WTIMER0CC2 | LDMA_CH_REQSEL_SOURCESEL_WTIMER0,                 ///< Trig on WTIMER0_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER0CC3)
	LdmaClassSignal_WTIMER0_CC3 = LDMA_CH_REQSEL_SIGSEL_WTIMER0CC3 | LDMA_CH_REQSEL_SOURCESEL_WTIMER0,                 ///< Trig on WTIMER0_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER0UFOF)
	LdmaClassSignal_WTIMER0_UFOF = LDMA_CH_REQSEL_SIGSEL_WTIMER0UFOF | LDMA_CH_REQSEL_SOURCESEL_WTIMER0,               ///< Trig on WTIMER0_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER1CC0)
	LdmaClassSignal_WTIMER1_CC0 = LDMA_CH_REQSEL_SIGSEL_WTIMER1CC0 | LDMA_CH_REQSEL_SOURCESEL_WTIMER1,                 ///< Trig on WTIMER1_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER1CC1)
	LdmaClassSignal_WTIMER1_CC1 = LDMA_CH_REQSEL_SIGSEL_WTIMER1CC1 | LDMA_CH_REQSEL_SOURCESEL_WTIMER1,                 ///< Trig on WTIMER1_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER1CC2)
	LdmaClassSignal_WTIMER1_CC2 = LDMA_CH_REQSEL_SIGSEL_WTIMER1CC2 | LDMA_CH_REQSEL_SOURCESEL_WTIMER1,                 ///< Trig on WTIMER1_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER1CC3)
	LdmaClassSignal_WTIMER1_CC3 = LDMA_CH_REQSEL_SIGSEL_WTIMER1CC3 | LDMA_CH_REQSEL_SOURCESEL_WTIMER1,                 ///< Trig on WTIMER1_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER1UFOF)
	LdmaClassSignal_WTIMER1_UFOF = LDMA_CH_REQSEL_SIGSEL_WTIMER1UFOF | LDMA_CH_REQSEL_SOURCESEL_WTIMER1,               ///< Trig on WTIMER1_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER2CC0)
	LdmaClassSignal_WTIMER2_CC0 = LDMA_CH_REQSEL_SIGSEL_WTIMER2CC0 | LDMA_CH_REQSEL_SOURCESEL_WTIMER2,                 ///< Trig on WTIMER2_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER2CC1)
	LdmaClassSignal_WTIMER2_CC1 = LDMA_CH_REQSEL_SIGSEL_WTIMER2CC1 | LDMA_CH_REQSEL_SOURCESEL_WTIMER2,                 ///< Trig on WTIMER2_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER2CC2)
	LdmaClassSignal_WTIMER2_CC2 = LDMA_CH_REQSEL_SIGSEL_WTIMER2CC2 | LDMA_CH_REQSEL_SOURCESEL_WTIMER2,                 ///< Trig on WTIMER2_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER2CC3)
	LdmaClassSignal_WTIMER2_CC3 = LDMA_CH_REQSEL_SIGSEL_WTIMER2CC3 | LDMA_CH_REQSEL_SOURCESEL_WTIMER2,                 ///< Trig on WTIMER2_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER2UFOF)
	LdmaClassSignal_WTIMER2_UFOF = LDMA_CH_REQSEL_SIGSEL_WTIMER2UFOF | LDMA_CH_REQSEL_SOURCESEL_WTIMER2,               ///< Trig on WTIMER2_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER3CC0)
	LdmaClassSignal_WTIMER3_CC0 = LDMA_CH_REQSEL_SIGSEL_WTIMER3CC0 | LDMA_CH_REQSEL_SOURCESEL_WTIMER3,                 ///< Trig on WTIMER3_CC0.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER3CC1)
	LdmaClassSignal_WTIMER3_CC1 = LDMA_CH_REQSEL_SIGSEL_WTIMER3CC1 | LDMA_CH_REQSEL_SOURCESEL_WTIMER3,                 ///< Trig on WTIMER3_CC1.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER3CC2)
	LdmaClassSignal_WTIMER3_CC2 = LDMA_CH_REQSEL_SIGSEL_WTIMER3CC2 | LDMA_CH_REQSEL_SOURCESEL_WTIMER3,                 ///< Trig on WTIMER3_CC2.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER3CC3)
	LdmaClassSignal_WTIMER3_CC3 = LDMA_CH_REQSEL_SIGSEL_WTIMER3CC3 | LDMA_CH_REQSEL_SOURCESEL_WTIMER3,                 ///< Trig on WTIMER3_CC3.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_WTIMER3UFOF)
	LdmaClassSignal_WTIMER3_UFOF = LDMA_CH_REQSEL_SIGSEL_WTIMER3UFOF | LDMA_CH_REQSEL_SOURCESEL_WTIMER3,               ///< Trig on WTIMER3_UFOF.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART0RXDATAV)
	LdmaClassSignal_USART0_RXDATAV = LDMA_CH_REQSEL_SIGSEL_USART0RXDATAV | LDMA_CH_REQSEL_SOURCESEL_USART0,            ///< Trig on USART0_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART0TXBL)
	LdmaClassSignal_USART0_TXBL = LDMA_CH_REQSEL_SIGSEL_USART0TXBL | LDMA_CH_REQSEL_SOURCESEL_USART0,                  ///< Trig on USART0_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART0TXEMPTY)
	LdmaClassSignal_USART0_TXEMPTY = LDMA_CH_REQSEL_SIGSEL_USART0TXEMPTY | LDMA_CH_REQSEL_SOURCESEL_USART0,            ///< Trig on USART0_TXEMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART1RXDATAV)
	LdmaClassSignal_USART1_RXDATAV = LDMA_CH_REQSEL_SIGSEL_USART1RXDATAV | LDMA_CH_REQSEL_SOURCESEL_USART1,            ///< Trig on USART1_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART1RXDATAVRIGHT)
	LdmaClassSignal_USART1_RXDATAVRIGHT = LDMA_CH_REQSEL_SIGSEL_USART1RXDATAVRIGHT | LDMA_CH_REQSEL_SOURCESEL_USART1,  ///< Trig on USART1_RXDATAVRIGHT.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART1TXBL)
	LdmaClassSignal_USART1_TXBL = LDMA_CH_REQSEL_SIGSEL_USART1TXBL | LDMA_CH_REQSEL_SOURCESEL_USART1,                  ///< Trig on USART1_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART1TXBLRIGHT)
	LdmaClassSignal_USART1_TXBLRIGHT = LDMA_CH_REQSEL_SIGSEL_USART1TXBLRIGHT | LDMA_CH_REQSEL_SOURCESEL_USART1,        ///< Trig on USART1_TXBLRIGHT.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART1TXEMPTY)
	LdmaClassSignal_USART1_TXEMPTY = LDMA_CH_REQSEL_SIGSEL_USART1TXEMPTY | LDMA_CH_REQSEL_SOURCESEL_USART1,            ///< Trig on USART1_TXEMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART2RXDATAV)
	LdmaClassSignal_USART2_RXDATAV = LDMA_CH_REQSEL_SIGSEL_USART2RXDATAV | LDMA_CH_REQSEL_SOURCESEL_USART2,            ///< Trig on USART2_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART2RXDATAVRIGHT)
	LdmaClassSignal_USART2_RXDATAVRIGHT = LDMA_CH_REQSEL_SIGSEL_USART2RXDATAVRIGHT | LDMA_CH_REQSEL_SOURCESEL_USART2,  ///< Trig on USART2_RXDATAVRIGHT.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART2TXBL)
	LdmaClassSignal_USART2_TXBL = LDMA_CH_REQSEL_SIGSEL_USART2TXBL | LDMA_CH_REQSEL_SOURCESEL_USART2,                  ///< Trig on USART2_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART2TXBLRIGHT)
	LdmaClassSignal_USART2_TXBLRIGHT = LDMA_CH_REQSEL_SIGSEL_USART2TXBLRIGHT | LDMA_CH_REQSEL_SOURCESEL_USART2,        ///< Trig on USART2_TXBLRIGHT.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART2TXEMPTY)
	LdmaClassSignal_USART2_TXEMPTY = LDMA_CH_REQSEL_SIGSEL_USART2TXEMPTY | LDMA_CH_REQSEL_SOURCESEL_USART2,            ///< Trig on USART2_TXEMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART3RXDATAV)
	LdmaClassSignal_USART3_RXDATAV = LDMA_CH_REQSEL_SIGSEL_USART3RXDATAV | LDMA_CH_REQSEL_SOURCESEL_USART3,            ///< Trig on USART3_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART3RXDATAVRIGHT)
	LdmaClassSignal_USART3_RXDATAVRIGHT = LDMA_CH_REQSEL_SIGSEL_USART3RXDATAVRIGHT | LDMA_CH_REQSEL_SOURCESEL_USART3,  ///< Trig on USART3_RXDATAVRIGHT.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART3TXBL)
	LdmaClassSignal_USART3_TXBL = LDMA_CH_REQSEL_SIGSEL_USART3TXBL | LDMA_CH_REQSEL_SOURCESEL_USART3,                  ///< Trig on USART3_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART3TXBLRIGHT)
	LdmaClassSignal_USART3_TXBLRIGHT = LDMA_CH_REQSEL_SIGSEL_USART3TXBLRIGHT | LDMA_CH_REQSEL_SOURCESEL_USART3,        ///< Trig on USART3_TXBLRIGHT.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART3TXEMPTY)
	LdmaClassSignal_USART3_TXEMPTY = LDMA_CH_REQSEL_SIGSEL_USART3TXEMPTY | LDMA_CH_REQSEL_SOURCESEL_USART3,            ///< Trig on USART3_TXEMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART4RXDATAV)
	LdmaClassSignal_USART4_RXDATAV = LDMA_CH_REQSEL_SIGSEL_USART4RXDATAV | LDMA_CH_REQSEL_SOURCESEL_USART4,            ///< Trig on USART4_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART4RXDATAVRIGHT)
	LdmaClassSignal_USART4_RXDATAVRIGHT = LDMA_CH_REQSEL_SIGSEL_USART4RXDATAVRIGHT | LDMA_CH_REQSEL_SOURCESEL_USART4,  ///< Trig on USART4_RXDATAVRIGHT.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART4TXBL)
	LdmaClassSignal_USART4_TXBL = LDMA_CH_REQSEL_SIGSEL_USART4TXBL | LDMA_CH_REQSEL_SOURCESEL_USART4,                  ///< Trig on USART4_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART4TXBLRIGHT)
	LdmaClassSignal_USART4_TXBLRIGHT = LDMA_CH_REQSEL_SIGSEL_USART4TXBLRIGHT | LDMA_CH_REQSEL_SOURCESEL_USART4,        ///< Trig on USART4_TXBLRIGHT.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART4TXEMPTY)
	LdmaClassSignal_USART4_TXEMPTY = LDMA_CH_REQSEL_SIGSEL_USART4TXEMPTY | LDMA_CH_REQSEL_SOURCESEL_USART4,            ///< Trig on USART4_TXEMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART5RXDATAV)
	LdmaClassSignal_USART5_RXDATAV = LDMA_CH_REQSEL_SIGSEL_USART5RXDATAV | LDMA_CH_REQSEL_SOURCESEL_USART5,            ///< Trig on USART5_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART5RXDATAVRIGHT)
	LdmaClassSignal_USART5_RXDATAVRIGHT = LDMA_CH_REQSEL_SIGSEL_USART5RXDATAVRIGHT | LDMA_CH_REQSEL_SOURCESEL_USART5,  ///< Trig on USART5_RXDATAVRIGHT.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART5TXBL)
	LdmaClassSignal_USART5_TXBL = LDMA_CH_REQSEL_SIGSEL_USART5TXBL | LDMA_CH_REQSEL_SOURCESEL_USART5,                  ///< Trig on USART5_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART5TXBLRIGHT)
	LdmaClassSignal_USART5_TXBLRIGHT = LDMA_CH_REQSEL_SIGSEL_USART5TXBLRIGHT | LDMA_CH_REQSEL_SOURCESEL_USART5,        ///< Trig on USART5_TXBLRIGHT.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_USART5TXEMPTY)
	LdmaClassSignal_USART5_TXEMPTY = LDMA_CH_REQSEL_SIGSEL_USART5TXEMPTY | LDMA_CH_REQSEL_SOURCESEL_USART5,            ///< Trig on USART5_TXEMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_UART0RXDATAV)
	LdmaClassSignal_UART0_RXDATAV = LDMA_CH_REQSEL_SIGSEL_UART0RXDATAV | LDMA_CH_REQSEL_SOURCESEL_UART0,               ///< Trig on UART0_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_UART0TXBL)
	LdmaClassSignal_UART0_TXBL = LDMA_CH_REQSEL_SIGSEL_UART0TXBL | LDMA_CH_REQSEL_SOURCESEL_UART0,                     ///< Trig on UART0_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_UART0TXEMPTY)
	LdmaClassSignal_UART0_TXEMPTY = LDMA_CH_REQSEL_SIGSEL_UART0TXEMPTY | LDMA_CH_REQSEL_SOURCESEL_UART0,               ///< Trig on UART0_TXEMPTY.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_UART1RXDATAV)
	LdmaClassSignal_UART1_RXDATAV = LDMA_CH_REQSEL_SIGSEL_UART1RXDATAV | LDMA_CH_REQSEL_SOURCESEL_UART1,               ///< Trig on UART1_RXDATAV.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_UART1TXBL)
	LdmaClassSignal_UART1_TXBL = LDMA_CH_REQSEL_SIGSEL_UART1TXBL | LDMA_CH_REQSEL_SOURCESEL_UART1,                     ///< Trig on UART1_TXBL.
	#endif
	#if defined(LDMA_CH_REQSEL_SIGSEL_UART1TXEMPTY)
	LdmaClassSignal_UART1_TXEMPTY = LDMA_CH_REQSEL_SIGSEL_UART1TXEMPTY | LDMA_CH_REQSEL_SOURCESEL_UART1                ///< Trig on UART1_TXEMPTY.
	#endif
}											LdmaClassSignal_t;

#define LDMACLASS_MAX_XFER_COUNT (((_LDMA_CH_CTRL_XFERCNT_MASK >> _LDMA_CH_CTRL_XFERCNT_SHIFT) + 1))

typedef enum								LdmaClassStatus_e
{
	LdmaClassStatusOk = 0,
	LdmaClassStatusNotChannel,
	LdmaClassStatusFalled
}											LdmaClassStatus_t;

typedef struct								LdmaClassReceivedCyclical_s
{
	size_t									count_read;
	LDMA_Descriptor_t						descLink[1];
}											LdmaClassReceivedCyclical_t;

typedef struct								LdmaClassTransferSingle_s
{
	LDMA_Descriptor_t						descLink[2];
}											LdmaClassTransferSingle_t;

typedef struct								LdmaClassTransferI2cRequestFromMaster_s
{
	uint32_t								ctrl;
	LDMA_Descriptor_t						descLink[0x6];
	LDMA_Descriptor_t						descLinkAdd[0x4];
}											LdmaClassTransferI2cRequestFromMaster_t;

typedef struct								LdmaClassTransferCyclical_s
{
	LdmaClassReceivedCyclical_t				array;
}											LdmaClassTransferCyclical_t;

typedef union								LdmaClassChannel_u
{
	ssize_t									channel;
	struct
	{
		ssize_t								channel_1: 0x4;
		ssize_t								channel_2: 0x4;
	};
	
}											LdmaClassChannel_t;


class LdmaClass {
	public:
		LdmaClass(void) {};
		static size_t								ldmaGetDst(ssize_t channel) {return ((ssize_t)zunoSysCall(ZUNO_SYSFUNC_DMA_GETDST, 0x1, channel));};
		static size_t								ldmaGetSrc(ssize_t channel) {return ((ssize_t)zunoSysCall(ZUNO_SYSFUNC_DMA_GETSRC, 0x1, channel));};
		static size_t								receivedAvailable(ssize_t channel);
		static ssize_t								receivedReadPeek(ssize_t channel, uint8_t bBool);
		static ssize_t								receivedCyclical(const void *src, void *dst, size_t len, LdmaClassSignal_t signal, LDMA_CtrlSize_t size, LdmaClassReceivedCyclical_t *array);
		static ssize_t								transferCyclical(const void *src, void *dst, size_t len, LdmaClassSignal_t signal, LDMA_CtrlSize_t size, LdmaClassTransferCyclical_t *array);
		static ssize_t								transferSingle(const void *src, void *dst, size_t len, LdmaClassSignal_t signal, LDMA_CtrlSize_t size, LDMA_CtrlSrcInc_t srcInc, LDMA_CtrlDstInc_t dstInc, LdmaClassTransferSingle_t *array);
		static size_t								transferDone(ssize_t channel);
		static void									transferStop(ssize_t channel);
		// static void									transferStop(LdmaClassChannel_t channel);
		static void									i2cFixReceived(ssize_t channel);
		static ssize_t								i2cRequestFrom(I2C_TypeDef *i2c, void *dst, size_t len, LdmaClassSignal_t signal, LdmaClassTransferI2cRequestFromMaster_t *array);
};

#endif//LDMA_CLASS_H