/*
 * ZUNO_CoreDefs.h
 *
 *  Created on: 30 нояб. 2020 г.
 *      Author: alexanderpolyakov
 */

#ifndef SRC_ZUNO_COREDEFS_H_
#define SRC_ZUNO_COREDEFS_H_
#include <stdint.h>

#define MAX_SYS_PARAMS 8

enum {
	ZUNO_SYSFUNC_DELAY_MS,
	ZUNO_SYSFUNC_MILLIS,
	ZUNO_SYSFUNC_EEPROM_IO,
	ZUNO_SYSFUNC_EEPROM_ERASE,
	ZUNO_SYSFUNC_COMMIT_CONFIG,
	ZUNO_SYSFUNC_LEARN,
	ZUNO_SYSFUNC_SENDPACKET,
	ZUNO_SYSFUNC_GECKOEXT_CMUCLOCK,
	ZUNO_SYSFUNC_SLEEP_CONTROL,
	ZUNO_SYSFUNC_PERSISTENT_TIMER_CONTROL,
	ZUNO_SYSFUNC_MSGQUEUE_ALLOC,
	ZUNO_SYSFUNC_MSGQUEUE_SEND,
	ZUNO_SYSFUNC_MSGQUEUE_RCV,
	ZUNO_SYSFUNC_THREAD_CREATE,
	ZUNO_SYSFUNC_THREAD_SUSPEND,
	ZUNO_SYSFUNC_THREAD_RESUME,
	ZUNO_SYSFUNC_THREAD_GETCURRENTHANDLE,
	ZUNO_SYSFUNC_THREAD_ISRUNNING,
	ZUNO_SYSFUNC_THREAD_YIELD,
	ZUNO_SYSFUNC_ENTER_CRITICAL,
	ZUNO_SYSFUNC_EXIT_CRITICAL,
	ZUNO_SYSFUNC_INT_CONTROL,
	ZUNO_SYSFUNC_INT_CLEARPENDING,
	ZUNO_SYSFUNC_INT_SETPRIORITY,
	/*
	// OLD DMA 
    ZUNO_SYSFUNC_DMA_XFER,
    ZUNO_SYSFUNC_DMA_STOP,
    ZUNO_SYSFUNC_DMA_IS_PRC,
    ZUNO_SYSFUNC_DMA_COUNT,
	*/
	// NEW DMA
	ZUNO_SYSFUNC_DMA_GETDST,
	ZUNO_SYSFUNC_DMA_GETSRC,
	ZUNO_SYSFUNC_DMA_AVAILABLE,
	ZUNO_SYSFUNC_DMA_READ,
	ZUNO_SYSFUNC_DMA_CYCLIC,
	ZUNO_SYSFUNC_DMA_XFER_SINGLE,
	ZUNO_SYSFUNC_DMA_XFER_CYCLIC,
	ZUNO_SYSFUNC_DMA_XFER_DONE,
	ZUNO_SYSFUNC_DMA_XFER_STOP,
	ZUNO_SYSFUNC_DMA_I2C_RCV,
	ZUNO_SYSFUNC_DMA_I2C_REQUEST,
	
	ZUNO_SYSFUNC_SETDEFAULT,
	ZUNO_SYSFUNC_SENDNIF,
	ZUNO_SYSFUNC_PTI_CONFIG,
	ZUNO_SYSFUNC_THREAD_DATA,

	ZUNO_SYSFUNC_ASSOCIATION_NODE,
	//ZUNO_SYSFUNC_RADIO_STAT,
	
	ZUNO_SYSFUNC_MAX_NUMBER,
	ZUNO_SYSFUNC_TEST = 0xFE
};
enum {
    CMU_CLOCK_TYPE_HFPER,
    CMU_CLOCK_TYPE_ADC0,
    CMU_CLOCK_TYPE_TIMER0,
    CMU_CLOCK_TYPE_TIMER1,
    CMU_CLOCK_TYPE_I2C0,
	CMU_CLOCK_TYPE_I2C1,
	CMU_CLOCK_TYPE_USART0,
	CMU_CLOCK_TYPE_USART1,
	CMU_CLOCK_TYPE_USART2,
	CMU_CLOCK_TYPE_GPIO,
	CMU_CLOCK_TYPE_CSEN_HF,
	CMU_CLOCK_TYPE_CSEN_LF,
	CMU_CLOCK_TYPE_WTIMER0,
	CMU_CLOCK_TYPE_LDMA,
	CMU_CLOCK_TYPE_CRYPTO,
	CMU_CLOCK_TYPE_CRC,
	CMU_CLOCK_TYPE_RND,
	CMU_CLOCK_TYPE_HFLE,
	CMU_CLOCK_TYPE_LEUART0
};
enum {
	ZUNO_IRQVEC_GPIO_ODD,
	ZUNO_IRQVEC_GPIO_EVEN,
	ZUNO_IRQVEC_I2C0,
	ZUNO_IRQVEC_I2C1,
	ZUNO_IRQVEC_TIMER0,
	ZUNO_IRQVEC_TIMER1,
	ZUNO_IRQVEC_WTIMER0,
	ZUNO_IRQVEC_CSEN,
	ZUNO_IRQVEC_LDMA,
	ZUNO_IRQVEC_USART0_RX,
	ZUNO_IRQVEC_USART1_RX,
	ZUNO_IRQVEC_USART2_RX,
	ZUNO_IRQVEC_LEUART0_RX,
	ZUNO_IRQVEC_LESENCE

};
typedef struct IOQueueMsg_s{
	uint32_t 	type;
	uint32_t    param;
}  IOQueueMsg_t;

#endif /* SRC_ZUNO_COREDEFS_H_ */
